<template>
  <div class="d-flex flex-column">
    <p>ทำการยืม</p>
    <div class="d-flex flex-column">
      <div v-if="!loading" class="card d-flex flex-column mb-1">
        <v-skeleton-loader type="card"></v-skeleton-loader>
      </div>
      <div v-if="!loading" class="text-detail mb-1">
        <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      </div>
      <div v-if="!loading" class="text-detail mb-1">
        <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      </div>
      <div v-if="!loading" class="text-detail mb-1">
        <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
        <br>
      </div>
      <div v-if="!loading" class="text-detail mb-1">
        <v-skeleton-loader type="list-item-two-line"></v-skeleton-loader>
      </div>

      <div v-if="loading" class="d-flex flex-column card-text">
        <div class="d-flex justify-center">
          <v-img v-if="imgPath" :src="media + imgPath" :aspect-ratio="1" class="img" cover />
          <img v-else src="/assets/image/non-equipment.jpg" :aspect-ratio="1" class="img" cover />
        </div>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text">
        <div class="d-flex">
          <p>จาก</p>
          :
          <p>{{ serviceProvider }}</p>
        </div>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text">
        <div class="d-flex">
          <p>อุปกรณ์</p>
          :
          <p>{{ equipmentName }}</p>
        </div>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text">
        <div class="d-flex">
          <p>รายละเอียด</p>
          :
          <p v-if="detail">
            {{ detail }}
          </p>
          <p v-else> - </p>
        </div>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text">
        <div class="d-flex">
          <p>ระยะเวลาในการยืม</p>
          :
          <p>{{ dayLimit }} วัน</p>
        </div>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text">
        <div class="d-flex">
          <p>จำนวน</p>
          :
          <p>× 1</p>
        </div>
      </div>
      <div v-if="loading" class="d-flex flex-column card-text">
        <div class="d-flex">
          <p>กำหนดการคืน</p>
          :
          <p class="text-orange-darken-3">{{ returnSchedule }}</p>
        </div>
      </div>
      <br>

      <div v-if="loading" class="card-text d-flex justify-space-around mb-10">
        <v-btn @click="back" rounded="lg" width="150" variant="flat" class="text-black">
          <p>ยกเลิก</p>
        </v-btn>
        <v-btn @click="onBorrowEquipment" :disabled="quantity < 1" rounded="lg" width="150" variant="flat" color="#fcc200">
          <p>ยืนยัน</p>
        </v-btn>
      </div>

      <v-overlay :model-value="borrowLoading" class="align-center justify-center">
        <v-progress-circular color="amber-accent-4" indeterminate size="64"></v-progress-circular>
      </v-overlay>

      <v-col cols="auto">
        <v-dialog v-model="success" transition="dialog-top-transition" max-width="275">
          <template v-slot:default>
            <v-card rounded="xl">
              <div class="pb-5 text-center">
                <v-icon class="my-6" color="success" icon="mdi-check-circle-outline" size="128"></v-icon>
                <div class="t-text">ส่งคำร้องขอยืมเรียบร้อย</div>
                <p class="d-text">รอการอนุมัติจากผู้ให้บริการ</p>
              </div>
            </v-card>
          </template>
        </v-dialog>
      </v-col>
    </div>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | ยืนยันการยืม",
  meta: [{ name: "description", content: "ยืนยันการยืม" }],
});
definePageMeta({
  middleware: "auth",
});

import { ref } from "vue"
import axios from "axios"

const token = useStrapiToken();
const url = useStrapiUrl();
const media = useStrapiMedia();

const userData = ref()

const equipment = ref()
const equipmentId = ref()
const equipmentName = ref()
const detail = ref()
const dayLimit = ref()
const quantity = ref()
const serviceProvider = ref()
const imgPath = ref()
const returnSchedule = ref()
const returnScheduleData = ref()

const loading = ref(false)
const borrowLoading = ref(false)
const success = ref(false)

async function onBorrowEquipment() {
  borrowLoading.value = true
  console.log("loading : ", borrowLoading.value)

  try {
    axios.post(`${url}/requests`, {
      data: {
        status: 1,
        equipment: equipmentId.value,
        department: userData.value.department.id,
        borrower: userData.value.id,
      }
    }, {
      headers: {
        Authorization: `Bearer ${token.value}`,
      }
    }).then(async (response) => {
      console.log("Borrowed : ", response.data.data.id)

      await axios.put(`${url}/users/${userData.value.id}`, {
        requests: {
          connect: [response.data.data.id]
        }
      }, {
        headers: {
          Authorization: `Bearer ${token.value}`,
        }
      })

      console.log('Borrow request success')
    })

  } catch (error) {
    console.log(error)
  } finally {
    console.log("loaded : ", borrowLoading.value)
    await new Promise(resolve => setTimeout(resolve, 1500));
    borrowLoading.value = false
    success.value = true;
    setTimeout(() => (success.value = false), 3000);
    await new Promise(resolve => setTimeout(resolve, 3000));
    navigateTo('/');
  }
}

async function getEquipmentsFindOne() {
  loading.value = true
  try {
    const { id } = useRoute().params;
    await axios
      .get(`${url}/equipments/${id}`, {
        params: {
          populate: {
            image: {
              fields: {
                0: "url",
              },
            },
          },
        },
        headers: {
          Authorization: `Bearer ${token.value}`,
        },
      })
      .then((response) => {
        equipment.value = response.data.data;
        equipmentName.value = equipment.value.attributes.name
        equipmentId.value = equipment.value.id
        if (equipment.value.attributes.image.data != null) {
          imgPath.value = equipment.value.attributes.image.data[0].attributes.url;
        }
        detail.value = equipment.value.attributes.detail
        dayLimit.value = equipment.value.attributes.day_limit
        quantity.value = equipment.value.attributes.quantity
        serviceProvider.value = equipment.value.attributes.provider_name
        getReturnSchedule();
      });

  } catch (error) {
    console.log(error);
  } finally {
    loading.value = true
  }
}

async function getReturnSchedule() {
  const today = new Date();
  const returnDate = new Date(today.setDate(today.getDate() + dayLimit.value));
  const thaiDate = returnDate.toLocaleDateString('th-TH', {
    day: 'numeric',
    month: 'long',
    year: 'numeric'
  });

  returnSchedule.value = thaiDate;
  // เปลี่ยนแปลง format ของ returnScheduleData
  returnScheduleData.value = returnDate.toISOString().split('T')[0];
  console.log('ReturnScheduleData : ', returnScheduleData.value);

  return returnDate;
}

async function getUserDate() {
  const response = await axios.get(`${url}/users/me`, {
    params: {
      populate: {
        department: {
          fields: {
            0: 'id',
          }
        }
      }
    },
    headers: {
      'Authorization': `Bearer ${token.value}`,
    }
  })

  userData.value = response.data
}

async function back() {
  window.history.back();
}

onMounted(async () => {
  await getUserDate();
  await getEquipmentsFindOne();
});
</script>

<style scoped>
.container {
  display: flex;
  justify-content: center;
}

.img {
  width: 100%;
  max-width: 150px;
  margin: 5px;
  border-radius: 5px;
  box-shadow: 0 5px 10px rgba(0, 0, 0, 0.05);
}

.text-name {
  font-size: 18px;
  padding: 5px;
}

.card-text {
  border-radius: 5px;
  background-color: white;
  margin-bottom: 1px;
  padding: 5px 0;
}

.t-text {
  font-size: 24px;
  font-weight: bold;
}

.d-text {
  font-size: 18px;
}

p {
  font-size: 16px;
  width: 100%;
  padding: 2px 5px;
}
</style>
